//*****************************************************************************
//*****************************************************************************
//  FILENAME:  CMX_BlinkingLed.h
//  Version: 1.0, Updated on 2006/08/01 at 15:19:24 
//  Application: PSoC Express 2.0
//
//  DESCRIPTION:  Header file for the BlinkingLed Driver
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#ifndef CMX_BlinkingLed_include
#define CMX_BlinkingLed_include
#include "cmx_dio_chan.h" 
#include <M8C.h>

#define BLINKINGLED_pse_LED_Blink_ORDINAL  0
#define CMX_BLINKINGLED_COUNT 1

////////////////////////////////////////////////////////////////////////////////////////////
// parameter block
typedef struct
{
    BYTE BLINKINGLED_ID;              // Instance ID
    BYTE BLINKINGLED_DRIVESENSE;
    BYTE BLINKINGLED_INITIALSTATE;
    BYTE BLINKINGLED_BlinkRate;       // 0 to 100
    BYTE BLINKINGLED_INSTANCE;
    BYTE BLINKINGLED_ChannelID;
}CMX_BLINKINGLED_ParameterBlock;

//*********************
// Function Prototypes
//*********************
void CMX_BLINKINGLED_SetValue(const CMX_BLINKINGLED_ParameterBlock * pPBlock, BYTE bValue);
void CMX_BLINKINGLED_Instantiate(const CMX_BLINKINGLED_ParameterBlock * pPBlock);

#endif
