//*****************************************************************************
//*****************************************************************************
//  FILENAME:  CMX_PULSELED.h
//   Version: 1.0.0.2, Updated on 2006/08/01 at 15:25:26
//  Application: PSoC Express 2.0
//
//  DESCRIPTION:  Header file for the PULSELED Driver
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#ifndef CMX_PULSELED_include
#define CMX_PULSELED_include

#include <M8C.h>

#define PULSELED_pse_LED_Decay_ORDINAL  0
#define CMX_PULSELED_COUNT 1
////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////
// parameter block
typedef struct
{
    BYTE PULSELED_ID;					// Instance ID
    BYTE PULSELED_ChannelID;			// Channel ID
    unsigned int uLED_Decay_Grow_Time;	// Time to decay or grow LED intensivity
}CMX_PULSELED_ParameterBlock;

// Function Prototypes
void CMX_PULSELED_SetValue(const CMX_PULSELED_ParameterBlock * thisBLK, BYTE bState);
void CMX_PULSELED_Instantiate(const CMX_PULSELED_ParameterBlock * thisBLK);


#endif
