//----------------------------------------------------------------------------
// DriverDecl.h
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "CMX_GSWITCH.h"

#include "CMX_DIO.h"
#include "CMX_BLINKINGLED.h"
#include "CMX_PULSELED.h"

// Driver ID's
#define ID_pse_Button0 1
#define ID_pse_LED_OnOff 2
#define ID_pse_LED_Blink 3
#define ID_pse_LED_Decay 4

// Channel ID's
#define ID_DIO_14 0
#define ID_DIO_22 1
#define ID_DIO_23 2
#define ID_PWM_00 0
#define ID_SHADOWREGS_0 0
#define ID_SHADOWREGS_1 1
#define ID_SHADOWREGS_2 2

// Channel Type maximum count
#define CMX_DIGITAL_IO_CHAN_MAX 3
#define CMX_PWM_CHAN_MAX 1
#define CMX_SHADOW_MAX 3

// Channel Type instantiation count
#define CMX_DIGITAL_IO_CHAN_COUNT 3
#define CMX_PWM_CHAN_COUNT 1
#define CMX_SHADOW_COUNT 0

// Driver Parameter Block externs
extern CMX_GSWITCH_ParameterBlock const pse_Button0;
extern CMX_DIO_ParameterBlock const pse_LED_OnOff;
extern CMX_BLINKINGLED_ParameterBlock const pse_LED_Blink;
extern CMX_PULSELED_ParameterBlock const pse_LED_Decay;
