//
// SystemVars.c
//
//   Updates system variables
#include "CMXSystem.h"
#include "CMXSystemFunction.h"
#include "SystemConst.h"
#include "FunctionParamDecl.h"
#include "SystemVars.h"

// system variable structure definition
SYSTEM_VARS_STRUC SystemVars;

void pse_LED_Blink_TransferFunction()
{
	BYTE outputIndex;

	outputIndex = TableLookup(&pse_LED_Blink_TableLookup);

	if (outputIndex == ID_pse_LED_Blink_OFF)
	{
		SystemVars.ReadOnlyVars.pse_LED_Blink = 0;
	}
	else if (outputIndex == ID_pse_LED_Blink_ON)
	{
		SystemVars.ReadOnlyVars.pse_LED_Blink = 1;
	}
	else if (outputIndex == ID_pse_LED_Blink_BLINKING)
	{
		SystemVars.ReadOnlyVars.pse_LED_Blink = 2;
	}

}

void pse_LED_Decay_TransferFunction()
{
	BYTE outputIndex;

	outputIndex = TableLookup(&pse_LED_Decay_TableLookup);

	if (outputIndex == ID_pse_LED_Decay_DECAY_OFF)
	{
		SystemVars.ReadOnlyVars.pse_LED_Decay = 0;
	}
	else if (outputIndex == ID_pse_LED_Decay_GROW_ON)
	{
		SystemVars.ReadOnlyVars.pse_LED_Decay = 1;
	}

}

void pse_LED_OnOff_TransferFunction()
{
	BYTE outputIndex;

	outputIndex = TableLookup(&pse_LED_OnOff_TableLookup);

	if (outputIndex == ID_pse_LED_OnOff_OFF)
	{
		SystemVars.ReadOnlyVars.pse_LED_OnOff = 0;
	}
	else if (outputIndex == ID_pse_LED_OnOff_ON)
	{
		SystemVars.ReadOnlyVars.pse_LED_OnOff = 1;
	}

}

