	cpu LMM
	.module cmx_blinkingled.c
	.area text(rom, con, rel)
	.dbfile ./cmx_blinkingled.c
	.dbfunc e CMX_BLINKINGLED_Instantiate _CMX_BLINKINGLED_Instantiate fV
;         PPChan -> X+2
;     Blink_port -> X+1
;      Blink_pin -> X+0
;        pPBlock -> X-5
_CMX_BLINKINGLED_Instantiate::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 44
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  CMX_BlinkingLed.c
; //  Version: 1.0, Updated on 2006/08/01 at 15:19:24 
; //  Application: PSoC Express 2.0
; //
; //  DESCRIPTION:  This Driver controls the BLINKINGLED parameters and returns
; //                the percent duty cycle for the selected channel.
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "m8c.h"
; #include "CMX_BlinkingLed.h"
; #include "cmx.h"
; #include "projectproperties.h"
; #include "SystemTimer.h"
; 
; 
; BYTE BlinkingLedState[CMX_BLINKINGLED_COUNT];  // Allocate state byte for each instance
; BYTE BlinkingLedCount[CMX_BLINKINGLED_COUNT];  // Allocate count byte for each instance
;  
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: BLINKINGLED_Instantiate(pBlock)
; //
; //    DESCRIPTION: 
; //      Initialize this instance of the BlinkingLED
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    pPBlock  == Pointer to parameter block.
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; ////////////////////////////////////////////////////////////////////////////////
; 
; void CMX_BLINKINGLED_Instantiate(const CMX_BLINKINGLED_ParameterBlock * pPBlock)
; {
	.dbline 50
;     
;         BYTE Blink_pin;
;         BYTE Blink_port;
;         BYTE PPChan;
; 	
;         PPChan = DIOChannelPins[(pPBlock->BLINKINGLED_ChannelID)];   // Get pin and port info
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,5
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_DIOChannelPins
	adc [__r0],>_DIOChannelPins
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+2],A
	.dbline 51
;         Blink_pin = pinlu[(BYTE)(PPChan & 0x0F)];              // Create pin mask
	mov A,[X+2]
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_pinlu
	adc [__r0],>_pinlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 52
;         Blink_port = portlu[(BYTE)((PPChan & 0xF0) >>4)];      // Extract port address
	mov A,[X+2]
	and A,-16
	asr A
	asr A
	asr A
	asr A
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_portlu
	adc [__r0],>_portlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+1],A
	.dbline 54
; 
;         GlobalSelectDisconnect(Blink_pin,Blink_port);          // Disconnect Global
	push X
	mov A,[X+1]
	push A
	mov A,[X+0]
	pop X
	xcall _GlobalSelectDisconnect
	pop X
	.dbline 55
;         DiscreteDriveMode(Blink_pin,Blink_port,0x01);          // Set mode to Strong
	push X
	mov A,1
	push A
	mov A,[X+1]
	push A
	mov A,[X+0]
	push A
	xcall _DiscreteDriveMode
	add SP,-3
	pop X
	.dbline -2
	.dbline 57
; 
; }
L2:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l PPChan 2 c
	.dbsym l Blink_port 1 c
	.dbsym l Blink_pin 0 c
	.dbsym l pPBlock -5 pX
	.dbend
	.dbfunc e CMX_BLINKINGLED_SetValue _CMX_BLINKINGLED_SetValue fV
;       bPinPort -> X+7
;      bInstance -> X+6
;        thisBLK -> X+0
;          bMode -> X-6
;        pPBlock -> X-5
_CMX_BLINKINGLED_SetValue::
	.dbline -1
	push X
	mov X,SP
	add SP,8
	.dbline 83
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: BLINKINGLED_SetValue(pPBlock,  bMode)
; //
; //  DESCRIPTION: 
; //    Sets LED mode between Off, On, and Blink.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    pPBlock == Pointer to Parameter block
; //    bMode   == New Mode 
; //               0 = Off
; //               1 = On
; //               2 = Blink
; //
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; ////////////////////////////////////////////////////////////////////////////////
; 
; void CMX_BLINKINGLED_SetValue(const CMX_BLINKINGLED_ParameterBlock * pPBlock, BYTE bMode)
; {
	.dbline 89
;     BYTE bPinPort;
;     BYTE bInstance;
; 
;     CMX_BLINKINGLED_ParameterBlock  thisBLK;
; 
;     thisBLK = *pPBlock;   // Copy Parameter block into RAM for more efficient code generation.
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov [__r3],X
	mov REG[0xd5],7
	push X
	mov [__rX],0
	mov X,[__r1]
X0:
	push A
	romx
	mov REG[0xd0],>__r0
	mvi [__r3],A
	pop A
	inc X
	adc A,0
	inc [__rX]
	cmp [__rX],6
	jnz X0
	pop X
	.dbline 91
; 
;     bInstance = thisBLK.BLINKINGLED_INSTANCE;
	mov A,[X+4]
	mov [X+6],A
	.dbline 93
;         
;     if (bMode >= 2) {    // If Value is 2 or great, put LED in blink mode.
	cmp [X-6],2
	jc L5
X1:
	.dbline 93
	.dbline 95
; 
;        if ( (SystemTimer_bGetTickCntr() - BlinkingLedCount[bInstance]) >= thisBLK.BLINKINGLED_BlinkRate) {
	push X
	xcall _SystemTimer_bGetTickCntr
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	mov A,[X+6]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_BlinkingLedCount
	adc [__r2],>_BlinkingLedCount
	mov A,[__r2]
	mov REG[0xd4],A
	mvi A,[__r3]
	sub [__r0],A
	mov A,[__r0]
	cmp A,[X+3]
	jc L7
X2:
	.dbline 95
	.dbline 96
;           BlinkingLedCount[bInstance] = SystemTimer_bGetTickCntr();
	push X
	xcall _SystemTimer_bGetTickCntr
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	mov A,[X+6]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_BlinkingLedCount
	adc [__r2],>_BlinkingLedCount
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 97
;           BlinkingLedState[bInstance] ^= 0x01;
	mov A,[X+6]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_BlinkingLedState
	adc [__r0],>_BlinkingLedState
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	dec [__r1]
	mov [__r2],A
	xor [__r2],1
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[__r2]
	mvi [__r1],A
	.dbline 98
;        }
L7:
	.dbline 99
;        bMode = BlinkingLedState[bInstance];
	mov REG[0xd0],>__r0
	mov A,[X+6]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_BlinkingLedState
	adc [__r0],>_BlinkingLedState
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [X-6],A
	.dbline 100
;     }
L5:
	.dbline 102
; 
;     bPinPort = DIOChannelPins[(thisBLK.BLINKINGLED_ChannelID)]; 
	mov REG[0xd0],>__r0
	mov A,[X+5]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_DIOChannelPins
	adc [__r0],>_DIOChannelPins
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+7],A
	.dbline 103
; 	if ((thisBLK.BLINKINGLED_DRIVESENSE ^ bMode ) == 0) {   // Set LED to ON or OFF depending on mode.
	mov A,[X+1]
	xor A,[X-6]
	cmp A,0
	jnz L11
	.dbline 103
	.dbline 104
;        DISetPin(bPinPort,1);
	push X
	mov A,1
	push A
	mov A,[X+7]
	pop X
	xcall _DISetPin
	pop X
	.dbline 105
	xjmp L12
L11:
	.dbline 105
	.dbline 106
	push X
	mov A,0
	push A
	mov A,[X+7]
	pop X
	xcall _DISetPin
	pop X
	.dbline 107
L12:
	.dbline -2
	.dbline 108
;     } else {
;        DISetPin(bPinPort,0);
;     }
; }
L3:
	add SP,-8
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l bPinPort 7 c
	.dbsym l bInstance 6 c
	.dbsym l thisBLK 0 X
	.dbsym l bMode -6 c
	.dbsym l pPBlock -5 pX
	.dbend
	.area data(ram, con, rel)
	.dbfile ./cmx_blinkingled.c
_BlinkingLedCount::
	.byte 0
	.dbsym e BlinkingLedCount _BlinkingLedCount A[1:1]c
	.area data(ram, con, rel)
	.dbfile ./cmx_blinkingled.c
_BlinkingLedState::
	.byte 0
	.dbsym e BlinkingLedState _BlinkingLedState A[1:1]c
