	cpu LMM
	.module cmx_dio.c
	.area text(rom, con, rel)
	.dbfile ./cmx_dio.c
	.dbfunc e CMX_DIO_Instantiate _CMX_DIO_Instantiate fV
;        pinPort -> X+8
;            pin -> X+7
;           port -> X+6
;      thisBlock -> X+0
;        pPBlock -> X-5
_CMX_DIO_Instantiate::
	.dbline -1
	push X
	mov X,SP
	add SP,9
	.dbline 41
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  CMX_DIO.c
; //  Version: 1.0, Updated on 2006/06/28 at 17:27:16
; //  Application: PSoC Express 2.0
; //
; //  DESCRIPTION:  This Driver calls the low level driver performs
; //                individual pin input and drive.
; //
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; #include "m8c.h"
; #include "CMX_dio.h"
; #include "cmx.h"
; 
; // channel type header file
; #include "cmx_dio_chan.h"
; 
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: DIO_Instantiate(const CMS_DIO_ParameterBlock * pPBlock)
; //
; //  DESCRIPTION: 
; //    Initializes the DIO specified by the parameter block pointed to by pPBlock.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: pPBlock => Pointer to Parameter Block
; //
; //  RETURNS:  none.
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: Initialization for discrete I/O
; //  Initial conditions and drive mode set based on parameters set in
; //  DIO Parameter block
; ////////////////////////////////////////////////////////////////////////////////
; void CMX_DIO_Instantiate(const CMX_DIO_ParameterBlock * pPBlock)
; {
	.dbline 47
;         BYTE port;
;         BYTE pin;
;         BYTE pinPort;
; 
;         CMX_DIO_ParameterBlock  thisBlock;
;         thisBlock = *pPBlock;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov [__r3],X
	mov REG[0xd5],7
	push X
	mov [__rX],0
	mov X,[__r1]
X0:
	push A
	romx
	mov REG[0xd0],>__r0
	mvi [__r3],A
	pop A
	inc X
	adc A,0
	inc [__rX]
	cmp [__rX],6
	jnz X0
	pop X
	.dbline 49
; 
;         pinPort = DIOChannelPins[(thisBlock.ChannelID)];      // Get pin and port info
	mov A,[X+5]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_DIOChannelPins
	adc [__r0],>_DIOChannelPins
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+8],A
	.dbline 51
; 
;         pin  = pinlu[(BYTE)(pinPort & 0x0F)];           // Create pin mask
	mov A,[X+8]
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_pinlu
	adc [__r0],>_pinlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+7],A
	.dbline 52
;         port = portlu[(BYTE)((pinPort & 0xF0) >>4)];    // Extract port address
	mov A,[X+8]
	and A,-16
	asr A
	asr A
	asr A
	asr A
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_portlu
	adc [__r0],>_portlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+6],A
	.dbline 54
; 
;         GlobalSelectDisconnect(pin,port);               // Disconnect from Global bus
	push X
	mov A,[X+6]
	push A
	mov A,[X+7]
	pop X
	xcall _GlobalSelectDisconnect
	pop X
	.dbline 55
;         CMX_DIO_SetValue(pPBlock,thisBlock.Initial_bCondition);  // Set initial condition	
	mov A,[X+2]
	push A
	mov A,[X-5]
	push A
	mov A,[X-4]
	push A
	xcall _CMX_DIO_SetValue
	add SP,-3
	.dbline 57
; 
;         DiscreteDriveMode(pin,port,thisBlock.Initial_DriveMode);  // Set default drive mode
	push X
	mov A,[X+3]
	push A
	mov A,[X+6]
	push A
	mov A,[X+7]
	push A
	xcall _DiscreteDriveMode
	add SP,-3
	pop X
	.dbline -2
	.dbline 58
; }
L2:
	add SP,-9
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l pinPort 8 c
	.dbsym l pin 7 c
	.dbsym l port 6 c
	.dbsym l thisBlock 0 X
	.dbsym l pPBlock -5 pX
	.dbend
	.dbfunc e CMX_DIO_SetValue _CMX_DIO_SetValue fV
;        pinport -> X+0
;         bValue -> X-6
;        pPBlock -> X-5
_CMX_DIO_SetValue::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 78
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: DIO_SetValue(const CMS_DIO_ParameterBlock * pPBlock, BYTE bValue)
; //
; //  DESCRIPTION: 
; //     Sets the DIO to a 1 or 0 determined by bValue.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS:  
; //              pPBlock => Pointer to parameter block
; //              bValue  => Value to set
; //
; //  RETURNS:  none
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE:
; ///////////////////////////////////////////////////////////////////////////////
; void CMX_DIO_SetValue(const CMX_DIO_ParameterBlock * pPBlock, BYTE bValue)
; {
	.dbline 81
;     BYTE pinport;
; 
;     pinport = DIOChannelPins[(pPBlock->ChannelID)];
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,5
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_DIOChannelPins
	adc [__r0],>_DIOChannelPins
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 84
; 
; 
; 	if ((pPBlock->ON_bDefine ^ bValue ) == 0) {   // Same mode
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	mov A,[X-6]
	xor [__r0],A
	cmp [__r0],0
	jnz L7
	.dbline 84
	.dbline 85
;         DISetPin(pinport,1); 
	push X
	mov A,1
	push A
	mov A,[X+0]
	pop X
	xcall _DISetPin
	pop X
	.dbline 86
	xjmp L8
L7:
	.dbline 86
	.dbline 87
	push X
	mov A,0
	push A
	mov A,[X+0]
	pop X
	xcall _DISetPin
	pop X
	.dbline 88
L8:
	.dbline -2
	.dbline 89
;     } else {
;         DISetPin(pinport,0);
;     }
; }
L6:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l pinport 0 c
	.dbsym l bValue -6 c
	.dbsym l pPBlock -5 pX
	.dbend
	.dbfunc e CMX_DIO_GetValue _CMX_DIO_GetValue fc
;            pin -> X+3
;           port -> X+2
;       pinValue -> X+1
;        pinPort -> X+0
;        pPBlock -> X-5
_CMX_DIO_GetValue::
	.dbline -1
	push X
	mov X,SP
	add SP,6
	.dbline 108
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: DIO_GetValue(const CMS_DIO_ParameterBlock * pPBlock)
; //
; //  DESCRIPTION:
; //     Return the value of the DIO pointed to by the parameter block
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //             pPBlock => Pointer to DIO Parameter block
; //
; //  RETURNS: 
; //     Returns DIO status, 1 or 0
; //
; //  THEORY of OPERATION or PROCEDURE:
; ///////////////////////////////////////////////////////////////////////////////
; BYTE CMX_DIO_GetValue(const CMX_DIO_ParameterBlock * pPBlock)
; {
	.dbline 116
; 
;     BYTE port;
;     BYTE pin;
;     BYTE pinPort;
;     BYTE pinValue;
; 
; 
;     pinPort = DIOChannelPins[(pPBlock->ChannelID)] ;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,5
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_DIOChannelPins
	adc [__r0],>_DIOChannelPins
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 117
;     pin  = pinlu[(BYTE)(pinPort & 0x0F)];
	mov A,[X+0]
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_pinlu
	adc [__r0],>_pinlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+3],A
	.dbline 118
;     port = portlu[(BYTE)((pinPort & 0xF0) >> 4)];
	mov A,[X+0]
	and A,-16
	asr A
	asr A
	asr A
	asr A
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_portlu
	adc [__r0],>_portlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+2],A
	.dbline 120
; 
;     pinValue = DiscreteReadPin(pin,port);
	push X
	mov A,[X+2]
	push A
	mov A,[X+3]
	pop X
	xcall _DiscreteReadPin
	mov REG[0xd0],>__r0
	pop X
	mov [X+1],A
	.dbline 122
; 
;     if (pPBlock->ReadOutputPolarity == 0) // if output is to be inverted
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	cmp A,0
	jnz L10
	.dbline 123
;     {
	.dbline 124
;        pinValue  = !pinValue;   // invert output
	cmp [X+1],0
	jnz L13
	mov [X+5],1
	mov [X+4],0
	xjmp L14
L13:
	mov [X+5],0
	mov [X+4],0
L14:
	mov REG[0xd0],>__r0
	mov A,[X+5]
	mov [X+1],A
	.dbline 125
;     }
L10:
	.dbline 127
;     
;     return ( pinValue);
	mov A,[X+1]
	mov REG[0xd0],>__r0
	.dbline -2
L9:
	add SP,-6
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l pin 3 c
	.dbsym l port 2 c
	.dbsym l pinValue 1 c
	.dbsym l pinPort 0 c
	.dbsym l pPBlock -5 pX
	.dbend
