	cpu LMM
	.module cmx_gswitch.c
	.area text(rom, con, rel)
	.dbfile ./cmx_gswitch.c
	.dbfunc e CMX_GSWITCH_Instantiate _CMX_GSWITCH_Instantiate fV
;       HI_State -> X+5
;       Instance -> X+4
;            pin -> X+3
;           port -> X+2
;             DM -> X+1
;        pinPort -> X+0
;        pPBlock -> X-5
_CMX_GSWITCH_Instantiate::
	.dbline -1
	push X
	mov X,SP
	add SP,6
	.dbline 60
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  CMX_GSWITCH.c
; //  Version: 1.0.0.1, Updated on 2006/06/28 at 17:33:31
; //  Application: PSoC Express 2.0
; //
; //  DESCRIPTION:  This Driver calls the low level driver performs
; //                individual pin input and drive.
; //
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; #include "m8c.h"
; #include "CMX_GSWITCH.h"
; #include "cmx.h"
; #include "systemtimer.h"
; // channel type header file
; #include "CMX_DIO_CHAN.h"
; #include "SystemTimer.h"
; 
; // Button return values
; #define PRESSED       1
; #define NOT_PRESSED   0
; 
; // Drive Modes
; #define MODE_RES_PULL_DOWN  0
; #define MODE_HIZ            2
; #define MODE_RES_PULL_HI    3
; 
; // Button States
; #define BUTTON_OFF          0    // Button off, output off.  If button pressed advance state.
; #define BUTTON_ON_WAIT      1    // Ouput High, waiting for min delay, stay in this state until delay expires
; #define BUTTON_DELAY_MET    2    // Min delay met, next state depend on current state of button
; 
; 
; BYTE PushButtonState[CMX_GSWITCH_COUNT];
; BYTE PushButtonDelayCount[CMX_GSWITCH_COUNT];
; 
; 
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: GSWITCH_Instantiate(const CMX_GSWITCH_ParameterBlock * pPBlock)
; //
; //  DESCRIPTION: GSWITCH Initialization
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: Channel ID 
; //
; //  RETURNS:
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: Initialization for discrete I/O
; //  Initial conditions and drive mode set based on parameters set in
; //  GSWITCH Parameter block
; ////////////////////////////////////////////////////////////////////////////////
; void CMX_GSWITCH_Instantiate(const CMX_GSWITCH_ParameterBlock * pPBlock)
; {
	.dbline 68
;    BYTE HI_State;
;    BYTE port;
;    BYTE pin;
;    BYTE pinPort;
;    BYTE DM;
;    BYTE Instance;
; 
;    HI_State = pPBlock->InputActiveState;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+5],A
	.dbline 69
;    DM = pPBlock->DriveMode;	
	mov A,[X-4]
	add A,3
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+1],A
	.dbline 71
; 
;    pinPort = DIOChannelPins[(pPBlock->ChannelID)]; // Get pin and port info
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_DIOChannelPins
	adc [__r0],>_DIOChannelPins
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 72
;    pin  = pinlu[(BYTE)(pinPort & 0x0F)];           // Create pin mask
	mov A,[X+0]
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_pinlu
	adc [__r0],>_pinlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+3],A
	.dbline 73
;    port = portlu[(BYTE)((pinPort & 0xF0) >>4)];    // Extract port address
	mov A,[X+0]
	and A,-16
	asr A
	asr A
	asr A
	asr A
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_portlu
	adc [__r0],>_portlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+2],A
	.dbline 75
; 
;    DiscreteDriveMode(pin,port,DM);	
	push X
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall _DiscreteDriveMode
	add SP,-3
	pop X
	.dbline 77
; 
;    if (DM == MODE_RES_PULL_DOWN)                   // Resistive pull low
	cmp [X+1],0
	jnz L3
	.dbline 78
;    {
	.dbline 79
;       DISetPin(pinPort, 0);
	push X
	mov A,0
	push A
	mov A,[X+0]
	pop X
	xcall _DISetPin
	pop X
	.dbline 80
;    }
	xjmp L4
L3:
	.dbline 81
;    else if (DM == MODE_HIZ)                        // Hi-Z input
	cmp [X+1],2
	jnz L5
	.dbline 82
;    {
	.dbline 83
;       DISetPin(pinPort, HI_State);
	push X
	mov A,[X+5]
	push A
	mov A,[X+0]
	pop X
	xcall _DISetPin
	pop X
	.dbline 84
;    }
	xjmp L6
L5:
	.dbline 85
;    else if (DM == MODE_RES_PULL_HI)                // Resistive pull High
	cmp [X+1],3
	jnz L7
	.dbline 86
;    {
	.dbline 87
;       DISetPin(pinPort, 1);
	push X
	mov A,1
	push A
	mov A,[X+0]
	pop X
	xcall _DISetPin
	pop X
	.dbline 88
;    }
L7:
L6:
L4:
	.dbline 91
; 
; 
;    Instance = pPBlock->Instance;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+4],A
	.dbline 92
;    PushButtonState[Instance] = BUTTON_OFF;
	mov A,[X+4]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_PushButtonState
	adc [__r0],>_PushButtonState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	.dbline -2
	.dbline 93
; }
L2:
	add SP,-6
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l HI_State 5 c
	.dbsym l Instance 4 c
	.dbsym l pin 3 c
	.dbsym l port 2 c
	.dbsym l DM 1 c
	.dbsym l pinPort 0 c
	.dbsym l pPBlock -5 pX
	.dbend
	.dbfunc e CMX_GSWITCH_GetValue _CMX_GSWITCH_GetValue fc
;            pin -> X+4
;           port -> X+3
;    returnValue -> X+2
;      bInstance -> X+1
;        pinPort -> X+0
;        pPBlock -> X-5
_CMX_GSWITCH_GetValue::
	.dbline -1
	push X
	mov X,SP
	add SP,5
	.dbline 122
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: GSWITCH_GetValue(const CMX_GSWITCH_ParameterBlock * pPBlock)
; //
; //  DESCRIPTION:
; //    Get current value of pushbutton.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: Channel ID
; //
; //  RETURNS: BYTE
; //
; //  THEORY of OPERATION or PROCEDURE:
; //    The pushbutton driver is more than just a simple get state of a button.
; //    It guarentes that a minimum button on time will be met.  The button
; //    state will go active as soon as the button state is detected on.  If
; //    the button goes low, the driver output will stay high for at least the
; //    minimum delay time.  If the button goes low and the minimum high time
; //    has already been met, the output will go low immediatly.
; //
; //  Button States:
; //       BUTTON_OFF       0    // Button not on and output was not on.
; //       BUTTON_TRAN_HI   1    // Button just pressed, but has not met min time
; //       BUTTON_DELAY_MET 2    // Button on and has min on time, may be turned off at any time.
; //
; ///////////////////////////////////////////////////////////////////////////////
; BYTE CMX_GSWITCH_GetValue(const CMX_GSWITCH_ParameterBlock * pPBlock)
; {
	.dbline 130
; 
;    BYTE port;
;    BYTE pin;
;    BYTE pinPort;
;    BYTE bInstance;
;    BYTE returnValue;
; 
;    pinPort = DIOChannelPins[(pPBlock->ChannelID)];   // Get pin and port info
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_DIOChannelPins
	adc [__r0],>_DIOChannelPins
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 131
;    pin     = pinlu[(BYTE)(pinPort & 0x0F)];          // Create pin mask
	mov A,[X+0]
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_pinlu
	adc [__r0],>_pinlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+4],A
	.dbline 132
;    port    = portlu[(BYTE)((pinPort & 0xF0) >>4)];   // Extract port address
	mov A,[X+0]
	and A,-16
	asr A
	asr A
	asr A
	asr A
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_portlu
	adc [__r0],>_portlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+3],A
	.dbline 134
; 
;    bInstance  = pPBlock->Instance;
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+1],A
	.dbline 136
; 
;    returnValue = NOT_PRESSED;                                          // By default button not pressed
	mov [X+2],0
	.dbline 138
;    
;    if(!(DiscreteReadPin(pin,port) ^ pPBlock->InputActiveState)) {      // Check if Button is pressed
	push X
	mov A,[X+3]
	push A
	mov A,[X+4]
	pop X
	xcall _DiscreteReadPin
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	mov A,[X-4]
	add A,2
	mov [__r3],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r3]
	romx
	pop X
	xor [__r0],A
	cmp [__r0],0
	jnz L10
	.dbline 138
	.dbline 140
;                                                                        // Button is pressed
;       if (PushButtonState[bInstance] == BUTTON_OFF) {
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_PushButtonState
	adc [__r0],>_PushButtonState
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,0
	jnz L12
	.dbline 140
	.dbline 141
;          PushButtonDelayCount[bInstance] = SystemTimer_bGetTickCntr();  // Start debouce timer
	push X
	xcall _SystemTimer_bGetTickCntr
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	mov A,[X+1]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_PushButtonDelayCount
	adc [__r2],>_PushButtonDelayCount
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 142
;          PushButtonState[bInstance] = BUTTON_ON_WAIT;
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_PushButtonState
	adc [__r0],>_PushButtonState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	.dbline 144
	xjmp L11
L12:
	.dbline 144
; 
;       } else if (PushButtonState[bInstance] == BUTTON_ON_WAIT) {       // Waiting for debouce timeout?
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_PushButtonState
	adc [__r0],>_PushButtonState
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,1
	jnz L14
	.dbline 144
	.dbline 146
; 
;          if ((SystemTimer_bGetTickCntr() - PushButtonDelayCount[bInstance]) > 1 ) { // Check if debounce?
	push X
	xcall _SystemTimer_bGetTickCntr
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	mov A,[X+1]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_PushButtonDelayCount
	adc [__r2],>_PushButtonDelayCount
	mov A,[__r2]
	mov REG[0xd4],A
	mvi A,[__r3]
	sub [__r0],A
	mov A,1
	cmp A,[__r0]
	jnc L11
X0:
	.dbline 146
	.dbline 147
;             PushButtonState[bInstance] = BUTTON_DELAY_MET;
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_PushButtonState
	adc [__r0],>_PushButtonState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,2
	mvi [__r1],A
	.dbline 148
;             returnValue = PRESSED;
	mov [X+2],1
	.dbline 149
;          }
	.dbline 151
	xjmp L11
L14:
	.dbline 151
; 
;       } else {                                                         // Button still pressed
	.dbline 152
;           returnValue = PRESSED;
	mov [X+2],1
	.dbline 153
;       }
	.dbline 155
	xjmp L11
L10:
	.dbline 155
; 
;    } else {                                                            // Button released
	.dbline 156
;       PushButtonState[bInstance] = BUTTON_OFF;                         // Reset state
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_PushButtonState
	adc [__r0],>_PushButtonState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	.dbline 157
;    }
L11:
	.dbline 159
; 
;    return ( returnValue);
	mov A,[X+2]
	mov REG[0xd0],>__r0
	.dbline -2
L9:
	add SP,-5
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l pin 4 c
	.dbsym l port 3 c
	.dbsym l returnValue 2 c
	.dbsym l bInstance 1 c
	.dbsym l pinPort 0 c
	.dbsym l pPBlock -5 pX
	.dbend
	.area data(ram, con, rel)
	.dbfile ./cmx_gswitch.c
_PushButtonDelayCount::
	.byte 0
	.dbsym e PushButtonDelayCount _PushButtonDelayCount A[1:1]c
	.area data(ram, con, rel)
	.dbfile ./cmx_gswitch.c
_PushButtonState::
	.byte 0
	.dbsym e PushButtonState _PushButtonState A[1:1]c
