	cpu LMM
	.module cmx_pulseled.c
	.area text(rom, con, rel)
	.dbfile ./cmx_pulseled.c
	.dbfunc e CMX_PULSELED_Instantiate _CMX_PULSELED_Instantiate fV
;      bInstance -> X+0
;        thisBLK -> X-5
_CMX_PULSELED_Instantiate::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 54
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  CMX_PULSELED.c
; //  Version: 1.0.0.2, Updated on 2006/08/01 at 15:25:26
; //  Application: PSoC Express 2.0
; //
; //  DESCRIPTION:  This Driver controls the PULSELED parameters and returns
; //                the percent duty cycle for the selected channel.
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2006. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "m8c.h"
; #include "CMX_PULSELED.h"
; #include "cmx.h"
; #include "SystemTimer.h"
; // Channel type header file
; #include "CMX_PWM_CHAN.h"
; 
; #define  FACTOR 100
; 
; #define CMX_DECAY_OFF        0    // LED output decay off.
; #define CMX_GROW_ON          1    // LED output grow  on.
; #define STM_LED_ON           2    // LED output fully on.
; #define STM_LED_OFF          3    // LED output fully off.
; 
; // Start time for each instance of driver in System Timer ticks
; unsigned int uPULSELEDCount[CMX_PULSELED_COUNT];  
; // Array for saving previous state of LED output for each instance of driver
; BYTE     bPrevPULSELEDState[CMX_PULSELED_COUNT];  
; 
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: CMX_PULSELED_Instantiate(const CMX_PULSELED_ParameterBlock * thisBLK)
; //
; //  DESCRIPTION: PULSELED Initialization
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    thisBLK  => Pointer to device parameter block
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE:
; //    Initialization of PULSELED. Initial state set to STM_LED_OFF.
; //
; ////////////////////////////////////////////////////////////////////////////////
; 
; void CMX_PULSELED_Instantiate(const CMX_PULSELED_ParameterBlock * thisBLK)
; {
	.dbline 57
;     BYTE bInstance;
; 
;     bInstance = thisBLK->PULSELED_ChannelID;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 58
;     bPrevPULSELEDState[thisBLK->PULSELED_ID] = STM_LED_OFF;
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_bPrevPULSELEDState
	adc [__r0],>_bPrevPULSELEDState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,3
	mvi [__r1],A
	.dbline 60
; 
;     PWMSetPolarity(bInstance,1);
	push X
	mov A,1
	push A
	mov A,[X+0]
	pop X
	xcall _PWMSetPolarity
	pop X
	.dbline 61
;     PWMSetDutyCycle(bInstance, 0);
	mov A,0
	push A
	mov A,[X+0]
	push A
	xcall _PWMSetDutyCycle
	add SP,-2
	.dbline 62
;     PWMStart(bInstance);
	push X
	mov A,[X+0]
	xcall _PWMStart
	pop X
	.dbline -2
	.dbline 63
; }
L2:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l bInstance 0 c
	.dbsym l thisBLK -5 pX
	.dbend
	.dbfunc e CMX_PULSELED_SetValue _CMX_PULSELED_SetValue fV
;            uDT -> X+6
; uDecayGrowTime -> X+4
; bPULSELEDDutyCycle -> X+3
;         uTicks -> X+1
;            bID -> X+0
;         bState -> X-6
;        thisBLK -> X-5
_CMX_PULSELED_SetValue::
	.dbline -1
	push X
	mov X,SP
	add SP,10
	.dbline 87
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: CMX_PULSELED_SetValue(CMX_PULSELED_ParameterBlock * thisBLK, BYTE bState)
; //
; //  DESCRIPTION: Sets the PWM duty cycle percent value
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    thisBLK       => Pointer to parameter block
; //    bState        => State of LED (GROW_ON or DECAY_OFF)
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION:
; //    LED output depends on bState, when it is GROW_ON the output will grow 
; //    exponentially until fully on, when it is DECAY_OFF it will decay 
; //    exponentially until fully off, based upon the decay/grow time property.
; //
; ////////////////////////////////////////////////////////////////////////////////
; 
; void CMX_PULSELED_SetValue(const CMX_PULSELED_ParameterBlock * thisBLK, BYTE bState)
; {
	.dbline 96
;     BYTE bID;						// Driver instance
;     BYTE bPULSELEDDutyCycle;		// Output PWM signal duty cycle
; 	
;     unsigned int uDecayGrowTime;	// Decay/Grow Time in ticks
; 	unsigned int uTicks;			// Current time in ticks from system timer
;     unsigned int uDT;				// Time left to final (fully on/fully off) state
; 
; 
;     bID = thisBLK->PULSELED_ID;		// Get instance number
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 98
; 
;     uDecayGrowTime = thisBLK->uLED_Decay_Grow_Time;	// Get Decay/Grow Time
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	mov [X+5],A
	mov A,[__r0]
	mov [X+4],A
	.dbline 99
;     uTicks = SystemTimer_iGetTickCntr();			// Get current system timer time
	push X
	xcall _SystemTimer_iGetTickCntr
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	mov [X+2],A
	mov A,[__r0]
	mov [X+1],A
	.dbline 101
; 
;     if (bState == CMX_GROW_ON)		// If output must grow
	cmp [X-6],1
	jnz L4
	.dbline 102
;     {
	.dbline 103
;         switch(bPrevPULSELEDState[bID])
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_bPrevPULSELEDState
	adc [__r0],>_bPrevPULSELEDState
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [X+9],A
	mov [X+8],0
	cmp [X+8],0
	jnz X2
	cmp [X+9],0
	jz L11
X2:
	cmp [X+8],0
	jnz X3
	cmp [X+9],1
	jz L14
X3:
	cmp [X+8],0
	jnz X4
	cmp [X+9],2
	jz L9
X4:
	cmp [X+8],0
	jnz X5
	cmp [X+9],3
	jz L10
X5:
	xjmp L5
X0:
	.dbline 104
;         {        
L9:
	.dbline 106
; 	        case STM_LED_ON:	// if already in fully on state do nothing
; 	            bPULSELEDDutyCycle = 100;
	mov [X+3],100
	.dbline 107
; 	            break;
	xjmp L5
L10:
	.dbline 110
; 
; 			case STM_LED_OFF:	// If previous state was fully off, start to grow
; 	            bPrevPULSELEDState[bID] = CMX_GROW_ON;
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_bPrevPULSELEDState
	adc [__r0],>_bPrevPULSELEDState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	.dbline 111
; 	            uPULSELEDCount[bID] = uTicks;		// Initialize start time
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_uPULSELEDCount
	adc [__r0],>_uPULSELEDCount
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[X+1]
	mvi [__r1],A
	mov A,[X+2]
	mvi [__r1],A
	.dbline 112
; 	            bPULSELEDDutyCycle = 0;
	mov [X+3],0
	.dbline 113
; 	            break;
	xjmp L5
L11:
	.dbline 116
; 
; 			case CMX_DECAY_OFF:	// If state changed from decay to grow modify the start time 
; 				bPrevPULSELEDState[bID] = CMX_GROW_ON; 
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_bPrevPULSELEDState
	adc [__r0],>_bPrevPULSELEDState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	.dbline 117
; 				uDT = uTicks - uPULSELEDCount[bID];             
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_uPULSELEDCount
	adc [__r0],>_uPULSELEDCount
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X+2]
	sub A,[__r1]
	mov [X+7],A
	mov A,[X+1]
	sbb A,[__r0]
	mov [X+6],A
	.dbline 118
; 				if(uDT<uDecayGrowTime)
	mov A,[X+7]
	sub A,[X+5]
	mov A,[X+6]
	sbb A,[X+4]
	jnc L12
X6:
	.dbline 119
; 					uPULSELEDCount[bID] = uTicks + uDT - uDecayGrowTime;
	mov REG[0xd0],>__r0
	mov A,[X+2]
	add A,[X+7]
	mov [__r1],A
	mov A,[X+1]
	adc A,[X+6]
	mov [__r0],A
	mov A,[X+5]
	sub [__r1],A
	mov A,[X+4]
	sbb [__r0],A
	mov A,[X+0]
	mov [__r3],A
	mov [__r2],0
	asl [__r3]
	rlc [__r2]
	add [__r3],<_uPULSELEDCount
	adc [__r2],>_uPULSELEDCount
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	xjmp L13
L12:
	.dbline 121
; 				else
; 				    uPULSELEDCount[bID]= uTicks;
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_uPULSELEDCount
	adc [__r0],>_uPULSELEDCount
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[X+1]
	mvi [__r1],A
	mov A,[X+2]
	mvi [__r1],A
L13:
L14:
	.dbline 124
; 				    
; 	        case CMX_GROW_ON:	// If already in GROW_ON then we continue to grow
; 	            uDT = uTicks - uPULSELEDCount[bID];	//get duration time in ticks
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_uPULSELEDCount
	adc [__r0],>_uPULSELEDCount
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X+2]
	sub A,[__r1]
	mov [X+7],A
	mov A,[X+1]
	sbb A,[__r0]
	mov [X+6],A
	.dbline 125
; 	            if (uDT <= uDecayGrowTime) 
	mov A,[X+5]
	sub A,[X+7]
	mov A,[X+4]
	sbb A,[X+6]
	jc L15
X7:
	.dbline 126
; 	            {   // Grow the LED
	.dbline 127
; 	                bPULSELEDDutyCycle = ((FACTOR*((long)uDT)))/uDecayGrowTime;  
	mov REG[0xd0],>__r0
	mov A,[X+5]
	mov [__r3],A
	mov A,[X+4]
	mov [__r2],A
	mov A,[X+7]
	mov [__r7],A
	mov A,[X+6]
	mov [__r6],A
	mov A,0
	push A
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,0
	push A
	push A
	push A
	mov A,100
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	mov A,0
	push A
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	pop A
	pop A
	add SP,-4
	mov A,[__r3]
	mov [X+3],A
	.dbline 129
; 	                
; 	            } 
	xjmp L5
L15:
	.dbline 131
; 	            else // If time exceeded turn to fully on state
; 	            {   
	.dbline 132
; 	                bPrevPULSELEDState[bID] = STM_LED_ON; 
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_bPrevPULSELEDState
	adc [__r0],>_bPrevPULSELEDState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,2
	mvi [__r1],A
	.dbline 133
; 	                bPULSELEDDutyCycle = 100;  
	mov [X+3],100
	.dbline 134
; 	            }           
	.dbline 135
; 	            break ;    
	.dbline 137
;         }           
;     } 
	xjmp L5
L4:
	.dbline 139
;     else // if (bState == CMX_DECAY_OFF) if output must decay
;     {
	.dbline 140
;         switch(bPrevPULSELEDState[bID])
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_bPrevPULSELEDState
	adc [__r0],>_bPrevPULSELEDState
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [X+9],A
	mov [X+8],0
	cmp [X+8],0
	jnz X8
	cmp [X+9],0
	jz L25
X8:
	cmp [X+8],0
	jnz X9
	cmp [X+9],1
	jz L22
X9:
	cmp [X+8],0
	jnz X10
	cmp [X+9],2
	jz L20
X10:
	cmp [X+8],0
	jnz X11
	cmp [X+9],3
	jz L21
X11:
	xjmp L17
X1:
	.dbline 141
;         {        
L20:
	.dbline 143
; 	        case STM_LED_ON:	// if LED was fully lit, start to decay
; 	            bPrevPULSELEDState[bID] = CMX_DECAY_OFF;
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_bPrevPULSELEDState
	adc [__r0],>_bPrevPULSELEDState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	.dbline 144
; 	            uPULSELEDCount[bID] = uTicks;        
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_uPULSELEDCount
	adc [__r0],>_uPULSELEDCount
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[X+1]
	mvi [__r1],A
	mov A,[X+2]
	mvi [__r1],A
	.dbline 145
; 	            bPULSELEDDutyCycle=100;
	mov [X+3],100
	.dbline 146
; 	            break;
	xjmp L18
L21:
	.dbline 149
; 	
; 	        case STM_LED_OFF:	// if already in fully off state do nothing
; 	            bPULSELEDDutyCycle = 0;        
	mov [X+3],0
	.dbline 150
; 	            break;
	xjmp L18
L22:
	.dbline 153
; 	
; 	        case CMX_GROW_ON:	// If state changed from grow to decay modify the start time       
; 				bPrevPULSELEDState[bID] = CMX_DECAY_OFF; 
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_bPrevPULSELEDState
	adc [__r0],>_bPrevPULSELEDState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	.dbline 154
; 				uDT = uTicks - uPULSELEDCount[bID];
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_uPULSELEDCount
	adc [__r0],>_uPULSELEDCount
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X+2]
	sub A,[__r1]
	mov [X+7],A
	mov A,[X+1]
	sbb A,[__r0]
	mov [X+6],A
	.dbline 155
; 				if(uDT<uDecayGrowTime)
	mov A,[X+7]
	sub A,[X+5]
	mov A,[X+6]
	sbb A,[X+4]
	jnc L23
X12:
	.dbline 156
; 					uPULSELEDCount[bID] = uTicks + uDT - uDecayGrowTime;            
	mov REG[0xd0],>__r0
	mov A,[X+2]
	add A,[X+7]
	mov [__r1],A
	mov A,[X+1]
	adc A,[X+6]
	mov [__r0],A
	mov A,[X+5]
	sub [__r1],A
	mov A,[X+4]
	sbb [__r0],A
	mov A,[X+0]
	mov [__r3],A
	mov [__r2],0
	asl [__r3]
	rlc [__r2]
	add [__r3],<_uPULSELEDCount
	adc [__r2],>_uPULSELEDCount
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	xjmp L24
L23:
	.dbline 158
; 				else
; 				    uPULSELEDCount[bID]= uTicks;
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_uPULSELEDCount
	adc [__r0],>_uPULSELEDCount
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[X+1]
	mvi [__r1],A
	mov A,[X+2]
	mvi [__r1],A
L24:
L25:
	.dbline 161
; 	
; 	        case CMX_DECAY_OFF:	// If already in CMX_DECAY_OFF then we continue to decay
; 	            uDT = uTicks - uPULSELEDCount[bID];   //get duration  time in ticks
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_uPULSELEDCount
	adc [__r0],>_uPULSELEDCount
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X+2]
	sub A,[__r1]
	mov [X+7],A
	mov A,[X+1]
	sbb A,[__r0]
	mov [X+6],A
	.dbline 162
; 	            if (uDT <= uDecayGrowTime) 
	mov A,[X+5]
	sub A,[X+7]
	mov A,[X+4]
	sbb A,[X+6]
	jc L26
X13:
	.dbline 163
; 	            {   // Decay the LED
	.dbline 164
; 	                bPULSELEDDutyCycle = 100 - ((FACTOR*((long)uDT)))/uDecayGrowTime;   
	mov REG[0xd0],>__r0
	mov A,[X+5]
	mov [__r3],A
	mov A,[X+4]
	mov [__r2],A
	mov A,[X+7]
	mov [__r7],A
	mov A,[X+6]
	mov [__r6],A
	mov A,0
	push A
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,0
	push A
	push A
	push A
	mov A,100
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	mov A,0
	push A
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [__r3],A
	pop A
	pop A
	pop A
	add SP,-4
	mov A,100
	sub A,[__r3]
	mov [X+3],A
	.dbline 165
; 	            } 
	xjmp L18
L26:
	.dbline 167
; 	            else // If time exceeded turn to fully off state
; 	            {   
	.dbline 168
; 	                bPrevPULSELEDState[bID] = STM_LED_OFF;
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_bPrevPULSELEDState
	adc [__r0],>_bPrevPULSELEDState
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,3
	mvi [__r1],A
	.dbline 169
; 	                bPULSELEDDutyCycle = 0;
	mov [X+3],0
	.dbline 170
; 	            }                    
	.dbline 171
; 	            break;
L17:
L18:
	.dbline 173
;         }           
;     }
L5:
	.dbline 175
;     // Control the LED intensity by setting the PWM signal duty cycle
;     PWMSetDutyCycle(thisBLK->PULSELED_ChannelID, bPULSELEDDutyCycle);
	mov A,[X+3]
	push A
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	push A
	xcall _PWMSetDutyCycle
	add SP,-2
	.dbline -2
	.dbline 176
; }
L3:
	add SP,-10
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l uDT 6 i
	.dbsym l uDecayGrowTime 4 i
	.dbsym l bPULSELEDDutyCycle 3 c
	.dbsym l uTicks 1 i
	.dbsym l bID 0 c
	.dbsym l bState -6 c
	.dbsym l thisBLK -5 pX
	.dbend
	.area data(ram, con, rel)
	.dbfile ./cmx_pulseled.c
_bPrevPULSELEDState::
	.byte 0
	.dbsym e bPrevPULSELEDState _bPrevPULSELEDState A[1:1]c
	.area data(ram, con, rel)
	.dbfile ./cmx_pulseled.c
_uPULSELEDCount::
	.byte 0,0
	.dbsym e uPULSELEDCount _uPULSELEDCount A[2:1]i
