	cpu LMM
	.module cmx_pwm_chan_c.c
	.area text(rom, con, rel)
	.dbfile ./cmx_pwm_chan_c.c
	.dbfunc e PWMSetDutyCycle _PWMSetDutyCycle fV
;   CompareValue -> X+1
;         Period -> X+0
;     bDutyCycle -> X-5
;            bID -> X-4
_PWMSetDutyCycle::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 36
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  cmx_pwm_chan.c
; //  @Version@
; //  `@PSOC_VERSION`
; //
; //  DESCRIPTION:  C file for the PWM channel.
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2001-2005. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "cmx_pwm_chan.h"
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: PWMSetDutyCycle(BYTE bID, BYTE bDutyCycle)
; //
; //  DESCRIPTION:  
; //    Sets the duty cycle for the given channel.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    bID        => Pointer to ParameterBlock for this instance.
; //    bDutyCycle =>
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; //
; //-----------------------------------------------------------------------------
; void PWMSetDutyCycle(BYTE bID, BYTE bDutyCycle)
; {
	.dbline 39
; 	BYTE Period;
; 	BYTE CompareValue;
; 	if (bDutyCycle > 100)
	mov A,100
	cmp A,[X-5]
	jnc L2
X0:
	.dbline 40
; 	{
	.dbline 41
; 		bDutyCycle = 100;
	mov [X-5],100
	.dbline 42
; 	}
L2:
	.dbline 43
; 	Period = PWMGetPeriod(bID);
	push X
	mov A,[X-4]
	xcall _PWMGetPeriod
	mov REG[0xd0],>__r0
	pop X
	mov [X+0],A
	.dbline 44
; 	CompareValue = ((int)(Period + 1) * (int)bDutyCycle)/100;
	mov A,[X-5]
	mov [__r1],A
	mov [__r0],0
	mov A,[X+0]
	mov [__r3],A
	mov [__r2],0
	add [__r3],1
	adc [__r2],0
	mov [__rX],0
	mov [__rY],0
X1:
	cmp [__r2],0
	jnz X4
	cmp [__r3],0
	jz X3
X4:
	and F,-5
	rrc [__r2]
	rrc [__r3]
	jnc X2
	mov REG[0xd0],>__r0
	mov A,[__r1]
	add [__rX],A
	mov A,[__r0]
	adc [__rY],A
X2:
	asl [__r1]
	rlc [__r0]
	jmp X1
X3:
	mov [__r1],[__rX]
	mov [__r0],[__rY]
	mov REG[0xd0],>__r0
	mov A,0
	push A
	mov A,100
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall __divmod_16X16_16
	pop A
	mov [__r1],A
	pop A
	add SP,-2
	mov A,[__r1]
	mov [X+1],A
	.dbline 45
;     PWMSetPulseWidth(bID, CompareValue);
	push X
	mov A,[X+1]
	push A
	mov A,[X-4]
	pop X
	xcall _PWMSetPulseWidth
	pop X
	.dbline -2
	.dbline 46
; }
L1:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l CompareValue 1 c
	.dbsym l Period 0 c
	.dbsym l bDutyCycle -5 c
	.dbsym l bID -4 c
	.dbend
