;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: PWM_00.inc
;;   Version: 2.5, Updated on 2006/05/15 at 15:09:31
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: Assembler declarations for the PWM8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for PWM_00 API's.
;--------------------------------------------------

PWM_00_CONTROL_REG_START_BIT:              equ 0x01    ; Control register start bit
PWM_00_INT_REG:                            equ 0x0e1
PWM_00_INT_MASK:                           equ 0x01


;--------------------------------------------------
; Constants for PWM_00 user defined values
;--------------------------------------------------

PWM_00_PERIOD:                             equ 0xf9
PWM_00_PULSE_WIDTH:                        equ 0x64


;--------------------------------------------------
; Register Address Constants for PWM_00
;--------------------------------------------------

PWM_00_COUNTER_REG:                    equ 0x20   ; DR0 Count register
PWM_00_PERIOD_REG:                     equ 0x21   ; DR1 Period register
PWM_00_COMPARE_REG:                    equ 0x22   ; DR2 Compare register
PWM_00_CONTROL_REG:                    equ 0x23   ; Control register
PWM_00_FUNC_REG:                       equ 0x20   ; Function register
PWM_00_INPUT_REG:                      equ 0x21   ; Input register
PWM_00_OUTPUT_REG:                     equ 0x22   ; Output register


;--------------------------------------------------
; PWM_00 Macro 'Functions'
;--------------------------------------------------

   macro PWM_00_Start_M
   or    reg[PWM_00_CONTROL_REG],  PWM_00_CONTROL_REG_START_BIT
   endm

   macro PWM_00_Stop_M
   and   reg[PWM_00_CONTROL_REG], ~PWM_00_CONTROL_REG_START_BIT
   endm

   macro PWM_00_EnableInt_M
   M8C_EnableIntMask PWM_00_INT_REG, PWM_00_INT_MASK
   endm

   macro PWM_00_DisableInt_M
   M8C_DisableIntMask PWM_00_INT_REG, PWM_00_INT_MASK
   endm


; end of file PWM_00.inc
