	cpu LMM
	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
_main::
	.dbline -1
	.dbline 21
; //----------------------------------------------------------------------------
; // C main line
; //----------------------------------------------------------------------------
; 
; #include <m8c.h>          // part specific constants and macros
; #include "PSoCAPI.h"      // PSoC API definitions for all User Modules
; 
; #include "driverdecl.h"
; #include "CMXSystem.h"
; #include "CMXSystemExtern.h"
; #include "TransferFunction.h"
; 
; #include "cmx.h"
; #include "ProjectProperties.h"
; #include "Custom.h"
; 
; // Channel includes
; 
; 
; void main()
; {
	.dbline 23
;     // Initialize Project
;     M8C_EnableGInt;                            // Turn on interrupts 
		or  F, 01h

	.dbline 24
;     I2C_CFG &= 0xFC;                           // Disable I2C in case it's not used.
	and REG[0xd6],-4
	.dbline 25
;     SystemTimer_Start();
	push X
	xcall _SystemTimer_Start
	.dbline 26
;     SystemTimer_SetInterval(SystemTimer_64_HZ);
	mov A,8
	xcall _SystemTimer_SetInterval
	.dbline 27
;     SystemTimer_EnableInt();
	xcall _SystemTimer_EnableInt
	pop X
	.dbline 33
; 
;     // Initialize Channels
; 
; 
;     // Initialize Variables
; 	SystemVars.ReadOnlyVars.pse_Button0 = 0;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars+2],0
	.dbline 34
; 	SystemVars.ReadOnlyVars.pse_LED_Blink = 0;
	mov [_SystemVars],0
	.dbline 35
; 	SystemVars.ReadOnlyVars.pse_LED_Decay = 0;
	mov [_SystemVars+3],0
	.dbline 36
; 	SystemVars.ReadOnlyVars.pse_LED_OnOff = 0;
	mov [_SystemVars+1],0
	.dbline 39
; 
;     // Driver instantiations
; CMX_GSWITCH_Instantiate(&pse_Button0);
	mov A,>_pse_Button0
	push A
	mov A,<_pse_Button0
	push A
	xcall _CMX_GSWITCH_Instantiate
	.dbline 40
; CMX_DIO_Instantiate(&pse_LED_OnOff);
	mov A,>_pse_LED_OnOff
	push A
	mov A,<_pse_LED_OnOff
	push A
	xcall _CMX_DIO_Instantiate
	add SP,-4
	.dbline 41
; CMX_DIO_SetValue(&pse_LED_OnOff, (BYTE)SystemVars.ReadOnlyVars.pse_LED_OnOff);
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars+1]
	push A
	mov A,>_pse_LED_OnOff
	push A
	mov A,<_pse_LED_OnOff
	push A
	xcall _CMX_DIO_SetValue
	.dbline 42
; CMX_BLINKINGLED_Instantiate(&pse_LED_Blink);
	mov A,>_pse_LED_Blink
	push A
	mov A,<_pse_LED_Blink
	push A
	xcall _CMX_BLINKINGLED_Instantiate
	add SP,-5
	.dbline 43
; CMX_BLINKINGLED_SetValue(&pse_LED_Blink, (BYTE)SystemVars.ReadOnlyVars.pse_LED_Blink);
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars]
	push A
	mov A,>_pse_LED_Blink
	push A
	mov A,<_pse_LED_Blink
	push A
	xcall _CMX_BLINKINGLED_SetValue
	.dbline 44
; CMX_PULSELED_Instantiate(&pse_LED_Decay);
	mov A,>_pse_LED_Decay
	push A
	mov A,<_pse_LED_Decay
	push A
	xcall _CMX_PULSELED_Instantiate
	add SP,-5
	.dbline 47
; 
;     // Custom initization code.
;     CustomInit();
	xcall _CustomInit
	xjmp L17
L16:
	.dbline 51
	.dbline 54
	push X
	mov X,0
	mov A,1
	xcall _SystemTimer_SyncWait
	pop X
	.dbline 57
	mov A,>_pse_Button0
	push A
	mov A,<_pse_Button0
	push A
	xcall _CMX_GSWITCH_GetValue
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars+2],A
	.dbline 60
	xcall _CustomPostInputUpdate
	.dbline 63
	xcall _TransferFunction
	.dbline 66
	xcall _CustomPreOutputUpdate
	.dbline 69
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars]
	push A
	mov A,>_pse_LED_Blink
	push A
	mov A,<_pse_LED_Blink
	push A
	xcall _CMX_BLINKINGLED_SetValue
	add SP,-5
	.dbline 70
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars+3]
	push A
	mov A,>_pse_LED_Decay
	push A
	mov A,<_pse_LED_Decay
	push A
	xcall _CMX_PULSELED_SetValue
	.dbline 71
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars+1]
	push A
	mov A,>_pse_LED_OnOff
	push A
	mov A,<_pse_LED_OnOff
	push A
	xcall _CMX_DIO_SetValue
	add SP,-6
	.dbline 73
L17:
	.dbline 50
	xjmp L16
X0:
	.dbline -2
	.dbline 74
;     // End Initialize Project
; 
; 	while(1)
; 	{
;         // Sync loop sample rate
; #if ( SAMPLE_DIVIDER  )
;         SystemTimer_SyncWait(SAMPLE_DIVIDER, SystemTimer_WAIT_RELOAD);
; #endif
; 		// update input variables
; 		SystemVars.ReadOnlyVars.pse_Button0 = CMX_GSWITCH_GetValue(&pse_Button0);
; 
;         // Custom Post Input function
;         CustomPostInputUpdate();
; 
; 		// run transfer function and update output variables
; 		TransferFunction();
; 
;         // CustomPreOutputUpdate();
;         CustomPreOutputUpdate();
; 
; 		// set outputs
; 		CMX_BLINKINGLED_SetValue(&pse_LED_Blink, (BYTE)SystemVars.ReadOnlyVars.pse_LED_Blink);
; 		CMX_PULSELED_SetValue(&pse_LED_Decay, (BYTE)SystemVars.ReadOnlyVars.pse_LED_Decay);
; 		CMX_DIO_SetValue(&pse_LED_OnOff, (BYTE)SystemVars.ReadOnlyVars.pse_LED_OnOff);
; 
; 	}
; }
L11:
	.dbline 0 ; func end
	jmp .
	.dbend
