	cpu LMM
	.module systemvars.c
	.area text(rom, con, rel)
	.dbfile ./systemvars.c
	.dbfunc e pse_LED_Blink_TransferFunction _pse_LED_Blink_TransferFunction fV
;    outputIndex -> X+0
_pse_LED_Blink_TransferFunction::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 15
; //
; // SystemVars.c
; //
; //   Updates system variables
; #include "CMXSystem.h"
; #include "CMXSystemFunction.h"
; #include "SystemConst.h"
; #include "FunctionParamDecl.h"
; #include "SystemVars.h"
; 
; // system variable structure definition
; SYSTEM_VARS_STRUC SystemVars;
; 
; void pse_LED_Blink_TransferFunction()
; {
	.dbline 18
; 	BYTE outputIndex;
; 
; 	outputIndex = TableLookup(&pse_LED_Blink_TableLookup);
	mov A,>_pse_LED_Blink_TableLookup
	push A
	mov A,<_pse_LED_Blink_TableLookup
	push A
	xcall _TableLookup
	add SP,-2
	mov [X+0],A
	.dbline 20
; 
; 	if (outputIndex == ID_pse_LED_Blink_OFF)
	cmp [X+0],0
	jnz L12
	.dbline 21
; 	{
	.dbline 22
; 		SystemVars.ReadOnlyVars.pse_LED_Blink = 0;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars],0
	.dbline 23
; 	}
	xjmp L13
L12:
	.dbline 24
; 	else if (outputIndex == ID_pse_LED_Blink_ON)
	cmp [X+0],1
	jnz L14
	.dbline 25
; 	{
	.dbline 26
; 		SystemVars.ReadOnlyVars.pse_LED_Blink = 1;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars],1
	.dbline 27
; 	}
	xjmp L15
L14:
	.dbline 28
; 	else if (outputIndex == ID_pse_LED_Blink_BLINKING)
	cmp [X+0],2
	jnz L16
	.dbline 29
; 	{
	.dbline 30
; 		SystemVars.ReadOnlyVars.pse_LED_Blink = 2;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars],2
	.dbline 31
; 	}
L16:
L15:
L13:
	.dbline -2
	.dbline 33
; 
; }
L11:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l outputIndex 0 c
	.dbend
	.dbfunc e pse_LED_Decay_TransferFunction _pse_LED_Decay_TransferFunction fV
;    outputIndex -> X+0
_pse_LED_Decay_TransferFunction::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 36
; 
; void pse_LED_Decay_TransferFunction()
; {
	.dbline 39
; 	BYTE outputIndex;
; 
; 	outputIndex = TableLookup(&pse_LED_Decay_TableLookup);
	mov A,>_pse_LED_Decay_TableLookup
	push A
	mov A,<_pse_LED_Decay_TableLookup
	push A
	xcall _TableLookup
	add SP,-2
	mov [X+0],A
	.dbline 41
; 
; 	if (outputIndex == ID_pse_LED_Decay_DECAY_OFF)
	cmp [X+0],0
	jnz L19
	.dbline 42
; 	{
	.dbline 43
; 		SystemVars.ReadOnlyVars.pse_LED_Decay = 0;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars+3],0
	.dbline 44
; 	}
	xjmp L20
L19:
	.dbline 45
; 	else if (outputIndex == ID_pse_LED_Decay_GROW_ON)
	cmp [X+0],1
	jnz L22
	.dbline 46
; 	{
	.dbline 47
; 		SystemVars.ReadOnlyVars.pse_LED_Decay = 1;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars+3],1
	.dbline 48
; 	}
L22:
L20:
	.dbline -2
	.dbline 50
; 
; }
L18:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l outputIndex 0 c
	.dbend
	.dbfunc e pse_LED_OnOff_TransferFunction _pse_LED_OnOff_TransferFunction fV
;    outputIndex -> X+0
_pse_LED_OnOff_TransferFunction::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 53
; 
; void pse_LED_OnOff_TransferFunction()
; {
	.dbline 56
; 	BYTE outputIndex;
; 
; 	outputIndex = TableLookup(&pse_LED_OnOff_TableLookup);
	mov A,>_pse_LED_OnOff_TableLookup
	push A
	mov A,<_pse_LED_OnOff_TableLookup
	push A
	xcall _TableLookup
	add SP,-2
	mov [X+0],A
	.dbline 58
; 
; 	if (outputIndex == ID_pse_LED_OnOff_OFF)
	cmp [X+0],0
	jnz L26
	.dbline 59
; 	{
	.dbline 60
; 		SystemVars.ReadOnlyVars.pse_LED_OnOff = 0;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars+1],0
	.dbline 61
; 	}
	xjmp L27
L26:
	.dbline 62
; 	else if (outputIndex == ID_pse_LED_OnOff_ON)
	cmp [X+0],1
	jnz L29
	.dbline 63
; 	{
	.dbline 64
; 		SystemVars.ReadOnlyVars.pse_LED_OnOff = 1;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars+1],1
	.dbline 65
; 	}
L29:
L27:
	.dbline -2
	.dbline 67
; 
; }
L25:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l outputIndex 0 c
	.dbend
	.area data(ram, con, rel)
	.dbfile ./systemvars.c
_SystemVars::
	.byte 0,0,0,0
	.dbsym e SystemVars _SystemVars X
