//*****************************************************************************
//*****************************************************************************
//  FILENAME:  `@LIB_NAME`_GSWITCH.h
//  Version: 1.0.0.1, Updated on 2006/06/28 at 17:33:31
//  Application: PSoC Express 2.0
//
//  DESCRIPTION:  Header file for Generic Switch driver 
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef GSWITCH_include
#define GSWITCH_include

#include <M8C.h>
`@GSWITCH_ORDINAL_DEFINE_BLOCK`
#define `@LIB_NAME`_GSWITCH_COUNT `@GSWITCH_COUNT`

////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////
// parameter block
typedef struct
{
    BYTE ID;                // Instance ID ( All drivers )
    BYTE Instance;          // DIO channel instance
    BYTE InputActiveState;  // 1 active Hi,0 active lo
    BYTE DriveMode;         // Pin IO Drive Mode, PU, PD, etc
    BYTE ChannelID;         // Pin and port, pin [3:0], port [7:4]
}`@LIB_NAME`_GSWITCH_ParameterBlock;

//-------------------------------------------------
// Prototypes of the GSWITCH API.
//-------------------------------------------------
extern void `@LIB_NAME`_GSWITCH_Instantiate(const CMX_GSWITCH_ParameterBlock * pPBlock);
extern BYTE `@LIB_NAME`_GSWITCH_GetValue(const CMX_GSWITCH_ParameterBlock * pPBlock);

#endif
