//
// TableLookup change management scripts
//
//
var g_sResultDOM;
var g_ResultXMLDoc;
var g_VarXMLDoc;
var g_ChangeXMLDoc;
var g_nImpact = 0;			// 0 = No impact, 1 = no teardown, 2 = no teardown null expression 3 = teardown, 4 = teardown w/output state loss
var g_nUpstreamImpact = 0;
var CMXVariable;
var oldCMXVariable;
//
// Input Qualification
//
//   assumes that g_sVarDOM loaded with input candidate DOM
//
//	 returns 1 = input qualified, 0 = input not qualified
//
function InputQual()
{
	var nRetVal = 1;

	// set up DOM
	g_SMScriptXMLDoc = new ActiveXObject("Microsoft.XMLDOM");
	g_SMScriptXMLDoc.validateOnParse	= false;
	g_SMScriptXMLDoc.loadXML(g_sVarDOM);

	// get the top variable DOM
	CMXVariable = g_SMScriptXMLDoc.selectSingleNode("//CMX_VARIABLE");
	if (CMXVariable != null)
	{
		var sType = CMXVariable.getAttribute("VALUE_TYPE");
		// must be discrete type
		if ((sType == "DISCRETE") || (sType == "CMX_DISCRETE"))
		{
			var ValueNodes = CMXVariable.selectNodes("//CMX_VALUE_LIST/CMX_VALUE");
			if (ValueNodes != null)
			{
				var nLength = ValueNodes.length;
				// need at least 2 values
				if (parseInt(nLength) > 1)
				{
					// values must be contiguous
					for (var ii=0;(ii < nLength) && (nRetVal == 1);ii++)
					{
						var ValueNode = ValueNodes[ii];
						var sValueType = ValueNode.getAttribute("TYPE");
						var sValue = ValueNode.getAttribute("VALUE");
						var sOrder = ValueNode.getAttribute("ORDER");
						if (sValueType == "EXPRESSION")
						{
							sValue = ValueNode.getAttribute("EXPRESSION_TEXT");
						}
						// no values greater than the count
						if (parseInt(sValue) < parseInt(nLength))
						{
							// value must equal order
							if (parseInt(sValue) != parseInt(sOrder))
							{
								nRetVal = 0;
							}
						}
						else
						{
							nRetVal = 0;
						}
					}
				}
				else
				{
					nRetVal = 0;
				}
			}
			else
			{
				nRetVal = 0;
			}
		}
		else
		{
			nRetVal = 0;
		}
	}
	else
	{
		nRetVal = 0;
	}

	return nRetVal;
}

//
// Change Evaluation
//
//   assumes that g_sVarDOM loaded with test variable DOM and g_sChangeDOM loaded with changing variable DOM
//
//   returns g_nImpact
//
function ChangeEval()
{
	// assume no impact
	g_nImpact = 0;

	// set up DOM
	g_SMScriptXMLDoc = new ActiveXObject("Microsoft.XMLDOM");
	g_SMScriptXMLDoc.validateOnParse	= false;
	g_SMScriptXMLDoc.loadXML(g_sChangeDOM);

	// get the top variable DOM
	CMXVariable = g_SMScriptXMLDoc.selectSingleNode("//CMX_NEW_VARIABLE/CMX_VARIABLE");
	oldCMXVariable = g_SMScriptXMLDoc.selectSingleNode("//CMX_CURRENT_VARIABLE/CMX_VARIABLE");
	if ((CMXVariable != null) && (oldCMXVariable != null))
	{
		// get the attributes
		var sType = CMXVariable.getAttribute("VALUE_TYPE");
		// get the old attributes
		var sOldType = oldCMXVariable.getAttribute("VALUE_TYPE");
		// new VALUE_TYPE must be discrete
		if ((sType == "DISCRETE") || (sType == "CMX_DISCRETE"))
		{
			var ValueNodes = CMXVariable.selectNodes("./CMX_VALUE_LIST/CMX_VALUE");
			var oldValueNodes = oldCMXVariable.selectNodes("./CMX_VALUE_LIST/CMX_VALUE");
			if ((ValueNodes != null) && (oldValueNodes != null))
			{
				var nLength = ValueNodes.length;
				var nOldLength = oldValueNodes.length;
				// number of values must be the same
				if (parseInt(nLength) != parseInt(nOldLength))
				{
					g_nImpact = 3;
				}
				else
				{
					// values must be contiguous
					for (var ii=0;(ii < nLength) && (g_nImpact == 0);ii++)
					{
						var ValueNode = ValueNodes[ii];
						var sValueType = ValueNode.getAttribute("TYPE");
						var sValue = ValueNode.getAttribute("VALUE");
						var sOrder = ValueNode.getAttribute("ORDER");
						if (sValueType == "EXPRESSION")
						{
							sValue = ValueNode.getAttribute("EXPRESSION_TEXT");
						}
						// no values greater than the count
						if (parseInt(sValue) < parseInt(nLength))
						{
							// value must equal order
							if (parseInt(sValue) != parseInt(sOrder))
							{
								g_nImpact = 3;
							}
						}
						else
						{
							g_nImpact = 3;
						}
					}
				}
			}
			else
			{
				g_nImpact = 3;
			}
		}
		else
		{
			g_nImpact = 3;
		}
	}
	else
	{
		g_nImpact = 10;
	}

	return g_nImpact;
}

function ChangeCommit()
{
	// no action.  Only value renaming necessary
}

//
// evaluates the variable for delete instance name
//
function DeleteEval( sInstanceName)
{
	g_nImpact = 3;	// teardown

	g_nUpstreamImpact = 0;  // no teardown upstream since we are keeping our values

	return g_nImpact;
}

//
// evaluates the variable for delete instance name
//
function DeleteCommit( sInstanceName)
{
	g_nImpact = 3;	// teardown

	g_nUpstreamImpact = 0;  // no teardown upstream since we are keeping our values

	return g_nImpact;
}

//
// retrieves the variable DOM, when loaded
//
function GetVarDOM()
{
	return g_sVarDOM;
}

//
// returns up stream impact after ChangeEval() run
//
function GetUpStreamImpact()
{
	return g_nUpstreamImpact;
}

//
// returns impact based on dependent input impact
//
function GetImpact(downStreamImpact)
{
	var nRetVal = 0;

	if (parseInt(downStreamImpact) != 0)
	{
		nRetVal = 4;
	}

	return nRetVal;
}

function GetResultDOM()
{
	return g_sResultDOM;
}

