<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
     version="1.0">

  <xsl:template match="CMX_TRANSFER_FUNCTION_SUMMARY[@TRANSFER_FUNCTION_TYPE='TableLookup']">

    <xsl:variable name="CmxTransferInstanceName">
      <xsl:value-of select="@INSTANCE_NAME" />
    </xsl:variable>


    <div class="divTransferFunction">
      <TABLE BORDER="0" CELLSPACING="0" class="dataTables">

        <th>
          Transfer Function:  <xsl:value-of select="$CmxTransferInstanceName"/><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>Table Lookup
        </th>

        <TR ALIGN="CENTER">
          <TD>

            <TABLE BORDER="1" CELLSPACING="0" class="dataTables">
              <TR>
                <TD class="columnHeading">OUTPUT NAME</TD>
                <TD class="columnHeading">EXPRESSION</TD>
              </TR>

              <xsl:for-each select="//CMX_VARIABLE_LIST/CMX_VARIABLE[@NAME=$CmxTransferInstanceName]/CMX_VALUE_LIST/CMX_VALUE">
                <xsl:sort data-type="number" order="ascending" select="./@ORDER"/>
                <TR>
                  <TD class="cell">
                    <xsl:value-of select="./@NAME"/>
                  </TD>

                  <TD class="cell">
                    <xsl:value-of select="./@EXPRESSION_TEXT"/>
                  </TD>
                </TR>
              </xsl:for-each>
            </TABLE>
          </TD>
        </TR>
        <tr>
          <td class="cell" colspan="2">
            <xsl:variable name="maxOrdinal">
              <xsl:value-of select="//CMX_VARIABLE_LIST/CMX_VARIABLE[@NAME=$CmxTransferInstanceName]/CMX_TRANSFERFUNCTION_LIST/CMX_TRANSFERFUNCTION/CMX_FUNCTION_LIST/CMX_FUNCTION/CMX_FUNCTION_PARAMETER_INSTANCE/CMX_STRUC_MEMBER_LIST/CMX_STRUC_MEMBER[@MEMBER_NAME='InputList']/CMX_ARRAY_ELEMENT_LIST/CMX_ARRAY_ELEMENT/@ARRAY_ORDINAL" />
            </xsl:variable>
            
            Input Value = 
            <xsl:for-each select="//CMX_VARIABLE_LIST/CMX_VARIABLE[@NAME=$CmxTransferInstanceName]/CMX_TRANSFERFUNCTION_LIST/CMX_TRANSFERFUNCTION/CMX_FUNCTION_LIST/CMX_FUNCTION/CMX_FUNCTION_PARAMETER_INSTANCE/CMX_STRUC_MEMBER_LIST/CMX_STRUC_MEMBER[@MEMBER_NAME='InputList']/CMX_ARRAY_ELEMENT_LIST/CMX_ARRAY_ELEMENT">
              <xsl:sort data-type="number" order="ascending" select="./@ARRAY_ORDINAL"/>

           
              <xsl:value-of select=".//CMX_STRUC_MEMBER[@MEMBER_NAME='instanceID']/@VALUE"/> *
              <xsl:value-of select=".//CMX_STRUC_MEMBER[@MEMBER_NAME='multiplier']/@VALUE"/>
              <xsl:if test="position()!=last()"> + </xsl:if>
            </xsl:for-each>
          </td>
        </tr>
        <tr>
          <td class="cell" ></td>
        </tr>
        <TR ALIGN="CENTER">
          <TD>

            <TABLE BORDER="1" CELLSPACING="0" class="dataTables">
              <TR>
                <TD class="columnHeading">INPUT VALUE</TD>
                <TD class="columnHeading">ASSIGNED OUTPUT</TD>
              </TR>

              <xsl:for-each select="//CMX_VARIABLE_LIST/CMX_VARIABLE[@NAME=$CmxTransferInstanceName]/CMX_TRANSFERFUNCTION_LIST/CMX_TRANSFERFUNCTION/CMX_FUNCTION_LIST/CMX_FUNCTION/CMX_FUNCTION_PARAMETER_INSTANCE/CMX_STRUC_MEMBER_LIST/CMX_STRUC_MEMBER[@MEMBER_NAME='LookupTable']/CMX_ARRAY_ELEMENT_LIST/CMX_ARRAY_ELEMENT">
                <xsl:sort data-type="number" order="ascending" select="./@ARRAY_ORDINAL"/>
                <TR>
                  <TD class="cell" >
                    <xsl:value-of select=".//@ARRAY_ORDINAL"/>
                  </TD>
                  <TD class="cell" >
                    <xsl:value-of select=".//@ARRAY_ELEMENT_VALUE"/>
                  </TD>
                </TR>
              </xsl:for-each>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
    </div>
  </xsl:template>
</xsl:stylesheet>