//
//  TableLookup.c
//
#include "CMXSystem.h"
#include "CMXSystemFunction.h"
#include "CMXSystemExtern.h"
#include "FunctionParamDecl.h"
#include "TableLookup.h"

BYTE TableLookup( TABLE_LOOKUP_PB const * pParamBlk)
{
	BYTE nRetVal = 0;
	BYTE nIndex;
	BYTE nLookUpIndex;
	BYTE inputInstanceID;
	
	// get the parameter block
	TABLE_LOOKUP_PB tableParams = *pParamBlk;
	// calculate lookup value
	nLookUpIndex = 0;
	for (nIndex = 0;nIndex < tableParams.InputListCount;nIndex++)
	{
		nLookUpIndex += *(tableParams.InputList[nIndex].pInputVar) * tableParams.InputList[nIndex].multiplier;
	}
	if (nLookUpIndex < tableParams.LookUpTableSize)
	{
		// set output value
		nRetVal = (tableParams.LookUpTable)[nLookUpIndex];
	}
	
	return nRetVal;
}