//
//  SimTransferFunction.js
//

// variable declarations
var g_Button0;
var g_LED_Blink;
var g_LED_Decay;
var g_LED_OnOff;

// variable ID's
var g_ID_Button0 = 0;
var g_ID_LED_Blink = 1;
var g_ID_LED_Decay = 2;
var g_ID_LED_OnOff = 3;

// function parameter ID's
var	g_ID_LED_Blink_TableLookup = 0;
var	g_ID_LED_Decay_TableLookup = 1;
var	g_ID_LED_OnOff_TableLookup = 2;

// function parameter defines
var g_LED_Blink_TableLookup_InputList_COUNT = 1;
var g_LED_Blink_TableLookup_LookupTable_COUNT = 2;
var g_LED_Decay_TableLookup_InputList_COUNT = 1;
var g_LED_Decay_TableLookup_LookupTable_COUNT = 2;
var g_LED_OnOff_TableLookup_InputList_COUNT = 1;
var g_LED_OnOff_TableLookup_LookupTable_COUNT = 2;

// function output states
// Button0 output state ID 
var	g_ID_Button0_Off = 0;
var	g_ID_Button0_On = 1;
var	g_ID_Button0_UNASSIGNED = 255;

// LED_Blink output state ID 
var	g_ID_LED_Blink_OFF = 0;
var	g_ID_LED_Blink_ON = 1;
var	g_ID_LED_Blink_BLINKING = 2;
var	g_ID_LED_Blink_UNASSIGNED = 255;

// LED_Decay output state ID 
var	g_ID_LED_Decay_DECAY_OFF = 0;
var	g_ID_LED_Decay_GROW_ON = 1;
var	g_ID_LED_Decay_UNASSIGNED = 255;

// LED_OnOff output state ID 
var	g_ID_LED_OnOff_OFF = 0;
var	g_ID_LED_OnOff_ON = 1;
var	g_ID_LED_OnOff_UNASSIGNED = 255;


// variable output state declarations
// Button0 output state declarations
var	g_Button0__Off;
var	g_Button0__On;
var	g_Button0__UNASSIGNED;

// LED_Blink output state declarations
var	g_LED_Blink__OFF;
var	g_LED_Blink__ON;
var	g_LED_Blink__BLINKING;
var	g_LED_Blink__UNASSIGNED;

// LED_Decay output state declarations
var	g_LED_Decay__DECAY_OFF;
var	g_LED_Decay__GROW_ON;
var	g_LED_Decay__UNASSIGNED;

// LED_OnOff output state declarations
var	g_LED_OnOff__OFF;
var	g_LED_OnOff__ON;
var	g_LED_OnOff__UNASSIGNED;


// function parameter declarations
var g_LED_Blink_TableLookup_PB = {};
var g_LED_Decay_TableLookup_PB = {};
var g_LED_OnOff_TableLookup_PB = {};

var g_FunctionParams = new Array();

// current value array
var g_CurrentValues = new Array();

function TransferFunction()
{
	// load values from globals
	var ioInfo;
	ioInfo = GetIOInfoFromInstanceName("Button0");
	if (ioInfo != null)
	{
		g_Button0 = parseInt(ioInfo.sValue);
	}
	ioInfo = GetIOInfoFromInstanceName("LED_Blink");
	if (ioInfo != null)
	{
		g_LED_Blink = parseInt(ioInfo.sValue);
	}
	ioInfo = GetIOInfoFromInstanceName("LED_Decay");
	if (ioInfo != null)
	{
		g_LED_Decay = parseInt(ioInfo.sValue);
	}
	ioInfo = GetIOInfoFromInstanceName("LED_OnOff");
	if (ioInfo != null)
	{
		g_LED_OnOff = parseInt(ioInfo.sValue);
	}

	// update current value array
	g_CurrentValues[g_ID_Button0] = g_Button0;
	g_CurrentValues[g_ID_LED_Blink] = g_LED_Blink;
	g_CurrentValues[g_ID_LED_Decay] = g_LED_Decay;
	g_CurrentValues[g_ID_LED_OnOff] = g_LED_OnOff;

	// call transfer functions
	LED_OnOff_TransferFunction();
	LED_Decay_TransferFunction();
	LED_Blink_TransferFunction();

	// set values in globals
	SetIOInfoValueFromInstanceName("Button0", g_Button0);
	SetIOInfoValueFromInstanceName("LED_Blink", g_LED_Blink);
	SetIOInfoValueFromInstanceName("LED_Decay", g_LED_Decay);
	SetIOInfoValueFromInstanceName("LED_OnOff", g_LED_OnOff);

}

function Button0_TransferFunction()
{
	


}

function LED_Blink_TransferFunction()
{
	var outputIndex;

	outputIndex = TableLookup(g_ID_LED_Blink_TableLookup);

	if (outputIndex == g_ID_LED_Blink_OFF)
	{
		g_LED_Blink = 0;
	}
	else if (outputIndex == g_ID_LED_Blink_ON)
	{
		g_LED_Blink = 1;
	}
	else if (outputIndex == g_ID_LED_Blink_BLINKING)
	{
		g_LED_Blink = 2;
	}

	g_CurrentValues[g_ID_LED_Blink] = g_LED_Blink; 

}

function LED_Decay_TransferFunction()
{
	var outputIndex;

	outputIndex = TableLookup(g_ID_LED_Decay_TableLookup);

	if (outputIndex == g_ID_LED_Decay_DECAY_OFF)
	{
		g_LED_Decay = 0;
	}
	else if (outputIndex == g_ID_LED_Decay_GROW_ON)
	{
		g_LED_Decay = 1;
	}

	g_CurrentValues[g_ID_LED_Decay] = g_LED_Decay; 

}

function LED_OnOff_TransferFunction()
{
	var outputIndex;

	outputIndex = TableLookup(g_ID_LED_OnOff_TableLookup);

	if (outputIndex == g_ID_LED_OnOff_OFF)
	{
		g_LED_OnOff = 0;
	}
	else if (outputIndex == g_ID_LED_OnOff_ON)
	{
		g_LED_OnOff = 1;
	}

	g_CurrentValues[g_ID_LED_OnOff] = g_LED_OnOff; 

}


function InitTransferFunctionGlobals()
{
	// LED_Blink_TableLookup parameter declarations
	var LED_Blink_TableLookup_InputList = new Array();

	var LED_Blink_TableLookupinputSetupElem000 = {};
	LED_Blink_TableLookupinputSetupElem000.InputVarID = g_ID_Button0;
	LED_Blink_TableLookupinputSetupElem000.multiplier = 1;
	LED_Blink_TableLookup_InputList[0] = LED_Blink_TableLookupinputSetupElem000;



	var LED_Blink_TableLookup_LookupTable = new Array();

	LED_Blink_TableLookup_LookupTable[0] = g_ID_LED_Blink_ON;
	LED_Blink_TableLookup_LookupTable[1] = g_ID_LED_Blink_BLINKING;


	g_LED_Blink_TableLookup_PB.InputList = LED_Blink_TableLookup_InputList;
	g_LED_Blink_TableLookup_PB.LookUpTable = LED_Blink_TableLookup_LookupTable;
	g_LED_Blink_TableLookup_PB.InputListCount = g_LED_Blink_TableLookup_InputList_COUNT;
	g_LED_Blink_TableLookup_PB.LookUpTableCount = g_LED_Blink_TableLookup_LookupTable_COUNT;

	g_FunctionParams[g_ID_LED_Blink_TableLookup] = g_LED_Blink_TableLookup_PB;
	// LED_Decay_TableLookup parameter declarations
	var LED_Decay_TableLookup_InputList = new Array();

	var LED_Decay_TableLookupinputSetupElem000 = {};
	LED_Decay_TableLookupinputSetupElem000.InputVarID = g_ID_Button0;
	LED_Decay_TableLookupinputSetupElem000.multiplier = 1;
	LED_Decay_TableLookup_InputList[0] = LED_Decay_TableLookupinputSetupElem000;



	var LED_Decay_TableLookup_LookupTable = new Array();

	LED_Decay_TableLookup_LookupTable[0] = g_ID_LED_Decay_GROW_ON;
	LED_Decay_TableLookup_LookupTable[1] = g_ID_LED_Decay_DECAY_OFF;


	g_LED_Decay_TableLookup_PB.InputList = LED_Decay_TableLookup_InputList;
	g_LED_Decay_TableLookup_PB.LookUpTable = LED_Decay_TableLookup_LookupTable;
	g_LED_Decay_TableLookup_PB.InputListCount = g_LED_Decay_TableLookup_InputList_COUNT;
	g_LED_Decay_TableLookup_PB.LookUpTableCount = g_LED_Decay_TableLookup_LookupTable_COUNT;

	g_FunctionParams[g_ID_LED_Decay_TableLookup] = g_LED_Decay_TableLookup_PB;
	// LED_OnOff_TableLookup parameter declarations
	var LED_OnOff_TableLookup_InputList = new Array();

	var LED_OnOff_TableLookupinputSetupElem000 = {};
	LED_OnOff_TableLookupinputSetupElem000.InputVarID = g_ID_Button0;
	LED_OnOff_TableLookupinputSetupElem000.multiplier = 1;
	LED_OnOff_TableLookup_InputList[0] = LED_OnOff_TableLookupinputSetupElem000;



	var LED_OnOff_TableLookup_LookupTable = new Array();

	LED_OnOff_TableLookup_LookupTable[0] = g_ID_LED_OnOff_OFF;
	LED_OnOff_TableLookup_LookupTable[1] = g_ID_LED_OnOff_ON;


	g_LED_OnOff_TableLookup_PB.InputList = LED_OnOff_TableLookup_InputList;
	g_LED_OnOff_TableLookup_PB.LookUpTable = LED_OnOff_TableLookup_LookupTable;
	g_LED_OnOff_TableLookup_PB.InputListCount = g_LED_OnOff_TableLookup_InputList_COUNT;
	g_LED_OnOff_TableLookup_PB.LookUpTableCount = g_LED_OnOff_TableLookup_LookupTable_COUNT;

	g_FunctionParams[g_ID_LED_OnOff_TableLookup] = g_LED_OnOff_TableLookup_PB;

	// variable output state initializations
	// Button0 output state initializations
	g_Button0__Off = 0;
	g_Button0__On = 1;
	g_Button0__UNASSIGNED = 0;

	// LED_Blink output state initializations
	g_LED_Blink__OFF = 0;
	g_LED_Blink__ON = 1;
	g_LED_Blink__BLINKING = 2;
	g_LED_Blink__UNASSIGNED = 0;

	// LED_Decay output state initializations
	g_LED_Decay__DECAY_OFF = 0;
	g_LED_Decay__GROW_ON = 1;
	g_LED_Decay__UNASSIGNED = 0;

	// LED_OnOff output state initializations
	g_LED_OnOff__OFF = 0;
	g_LED_OnOff__ON = 1;
	g_LED_OnOff__UNASSIGNED = 0;


	// variable initialization
	// initialize Button0 globals
    ioInfo = GetIOInfoFromInstanceName("Button0");
    if (ioInfo != null)
    {
		if ((ioInfo.sValue != null) && (ioInfo.sValue != ""))
		{
			g_Button0 = parseInt(ioInfo.sValue);
		}
		else
		{
			g_Button0 = 0;
		}
    }
	else
	{
		g_Button0 = 0;
	}
	// initialize LED_Blink globals
    ioInfo = GetIOInfoFromInstanceName("LED_Blink");
    if (ioInfo != null)
    {
		if ((ioInfo.sValue != null) && (ioInfo.sValue != ""))
		{
			g_LED_Blink = parseInt(ioInfo.sValue);
		}
		else
		{
			g_LED_Blink = 0;
		}
    }
	else
	{
		g_LED_Blink = 0;
	}
	// initialize LED_Decay globals
    ioInfo = GetIOInfoFromInstanceName("LED_Decay");
    if (ioInfo != null)
    {
		if ((ioInfo.sValue != null) && (ioInfo.sValue != ""))
		{
			g_LED_Decay = parseInt(ioInfo.sValue);
		}
		else
		{
			g_LED_Decay = 0;
		}
    }
	else
	{
		g_LED_Decay = 0;
	}
	// initialize LED_OnOff globals
    ioInfo = GetIOInfoFromInstanceName("LED_OnOff");
    if (ioInfo != null)
    {
		if ((ioInfo.sValue != null) && (ioInfo.sValue != ""))
		{
			g_LED_OnOff = parseInt(ioInfo.sValue);
		}
		else
		{
			g_LED_OnOff = 0;
		}
    }
	else
	{
		g_LED_OnOff = 0;
	}

}

InitTransferFunctionGlobals();


function TableLookup( instanceID)
{
	var nRetVal = 0;
	var nIndex;
	var nLookUpIndex;
	var inputInstanceID;
	
	// get the pointer to the parameter block
	var tableParams = g_FunctionParams[instanceID];
	// calculate lookup value
	nLookUpIndex = 0;
	for (nIndex = 0;nIndex < tableParams.InputListCount;nIndex++)
	{
		var inputIndex = tableParams.InputList[nIndex].InputVarID;
		var currentValue = g_CurrentValues[inputIndex];
		var multiplier = tableParams.InputList[nIndex].multiplier;

//		alert ("Input " + nIndex + " inputindex = " + inputIndex + " currentValue = " + currentValue + " multiplier = " + multiplier);
		nLookUpIndex += currentValue * multiplier;
	}
	if (nLookUpIndex < tableParams.LookUpTableCount)
	{
		// set output value
		nRetVal = tableParams.LookUpTable[nLookUpIndex];
	}
	
	return nRetVal;
}

function TableLookup( instanceID)
{
	var nRetVal = 0;
	var nIndex;
	var nLookUpIndex;
	var inputInstanceID;
	
	// get the pointer to the parameter block
	var tableParams = g_FunctionParams[instanceID];
	// calculate lookup value
	nLookUpIndex = 0;
	for (nIndex = 0;nIndex < tableParams.InputListCount;nIndex++)
	{
		var inputIndex = tableParams.InputList[nIndex].InputVarID;
		var currentValue = g_CurrentValues[inputIndex];
		var multiplier = tableParams.InputList[nIndex].multiplier;

//		alert ("Input " + nIndex + " inputindex = " + inputIndex + " currentValue = " + currentValue + " multiplier = " + multiplier);
		nLookUpIndex += currentValue * multiplier;
	}
	if (nLookUpIndex < tableParams.LookUpTableCount)
	{
		// set output value
		nRetVal = tableParams.LookUpTable[nLookUpIndex];
	}
	
	return nRetVal;
}

function TableLookup( instanceID)
{
	var nRetVal = 0;
	var nIndex;
	var nLookUpIndex;
	var inputInstanceID;
	
	// get the pointer to the parameter block
	var tableParams = g_FunctionParams[instanceID];
	// calculate lookup value
	nLookUpIndex = 0;
	for (nIndex = 0;nIndex < tableParams.InputListCount;nIndex++)
	{
		var inputIndex = tableParams.InputList[nIndex].InputVarID;
		var currentValue = g_CurrentValues[inputIndex];
		var multiplier = tableParams.InputList[nIndex].multiplier;

//		alert ("Input " + nIndex + " inputindex = " + inputIndex + " currentValue = " + currentValue + " multiplier = " + multiplier);
		nLookUpIndex += currentValue * multiplier;
	}
	if (nLookUpIndex < tableParams.LookUpTableCount)
	{
		// set output value
		nRetVal = tableParams.LookUpTable[nLookUpIndex];
	}
	
	return nRetVal;
}


function UpdateSimValues()
{
	// set values in globals
	SetIOInfoValueFromInstanceName("Button0", g_Button0);
	SetIOInfoValueFromInstanceName("LED_Blink", g_LED_Blink);
	SetIOInfoValueFromInstanceName("LED_Decay", g_LED_Decay);
	SetIOInfoValueFromInstanceName("LED_OnOff", g_LED_OnOff);
}

// update the input widgets
function UpdateInputWidgets()
{
//	alert("updating input widgets");
	for(var j  in g_IOInfos)
	{
        if (g_IOInfos[j].sType == "IN" || (g_IOInfos[j].sType == "VARIABLE" && g_IOInfos[j].sDriver == "Variable_IN"))
        {
			var sInstanceName = g_IOInfos[j].sInstanceName;
			var sID	= IDFromInstanceName(sInstanceName)
            var sValue	= g_IOInfos[j].sValue;
		    var sDriver	= g_IOInfos[j].sDriver;
//			alert("updating " + sInstanceName + " = " + sValue);
            sValue = RawToDisplayValue( sID, sValue);
		    WidgetSetValue(sDriver, sID, sValue);
		}
	}
}

function IOState( strID, strValue)
{
    this.strID = strID;
    this.strValue = strValue;
}
